pms/urls.py
from django.contrib import admin
from django.urls import path
from django.contrib import admin
from django.conf import settings as SETTINGS
from django.conf.urls.static import static
from django.urls import include, re_path
from core import views as core_views



urlpatterns = [
    re_path(r'^admin/', admin.site.urls),
    re_path(r'^app/accounts/', include('registration.backends.default.urls')),

    re_path(r'^$', core_views.App.as_view(), name='app'),
    re_path(r'^app/$', core_views.App.as_view(), name='app'),
    re_path(r'^app/dashboard/$', core_views.DashboardView.as_view(), name='dashboard'),

    re_path(r'^app/properties/', include('properties.urls')),
    re_path(r'^app/tenants/', include('tenants.urls')),





] + static(SETTINGS.STATIC_URL, document_root=SETTINGS.STATIC_ROOT) + static(SETTINGS.MEDIA_URL, document_root=SETTINGS.MEDIA_ROOT)

handler404 = 'core.views.page_not_found'
handler500 = 'core.views.error'
handler403 = 'core.views.permission_denied'
handler400 = 'core.views.bad_request'

properties/urls.py
from django.urls import re_path
from properties import views

app_name = 'properties'

urlpatterns = [
    # Feature year URLs
    re_path(r'^features/create/$', views.FeatureCreateView.as_view(), name='feature_create'),
    re_path(r'^features/view/(?P<pk>[0-9a-f-]+)/$', views.FeatureDetailView.as_view(), name='feature_view'),
    re_path(r'^features/list/$', views.FeatureListView.as_view(), name='feature_list'),
    re_path(r'^features/update/(?P<pk>[0-9a-f-]+)/$', views.FeatureUpdateView.as_view(), name='feature_update'),
    re_path(r'^features/delete/(?P<pk>[0-9a-f-]+)/$', views.FeatureDeleteView.as_view(), name='feature_delete'),
    # Property year URLs
    re_path(r'^properties/create/$', views.PropertyCreateView.as_view(), name='property_create'),
    re_path(r'^properties/view/(?P<pk>[0-9a-f-]+)/$', views.PropertyDetailView.as_view(), name='property_view'),
    re_path(r'^properties/list/$', views.PropertyListView.as_view(), name='property_list'),
    re_path(r'^properties/update/(?P<pk>[0-9a-f-]+)/$', views.PropertyUpdateView.as_view(), name='property_update'),
    re_path(r'^properties/delete/(?P<pk>[0-9a-f-]+)/$', views.PropertyDeleteView.as_view(), name='property_delete'),
]

tenants/urls.py
from django.urls import re_path
from tenants import views

app_name = 'tenants'

urlpatterns = [
    # DocumentType year URLs
    re_path(r'^document-type/create/$', views.DocumentTypeCreateView.as_view(), name='document_type_create'),
    re_path(r'^document-type/view/(?P<pk>[0-9a-f-]+)/$', views.DocumentTypeDetailView.as_view(), name='document_type_view'),
    re_path(r'^document-type/list/$', views.DocumentTypeListView.as_view(), name='document_type_list'),
    re_path(r'^document-type/update/(?P<pk>[0-9a-f-]+)/$', views.DocumentTypeUpdateView.as_view(), name='document_type_update'),
    re_path(r'^document-type/delete/(?P<pk>[0-9a-f-]+)/$', views.DocumentTypeDeleteView.as_view(), name='document_type_delete'),
    # Tenant year URLs
    re_path(r'^tenant/create/$', views.TenantCreateView.as_view(), name='tenant_create'),
    re_path(r'^tenant/view/(?P<pk>[0-9a-f-]+)/$', views.TenantDetailView.as_view(), name='tenant_view'),
    re_path(r'^tenant/list/$', views.TenantListView.as_view(), name='tenant_list'),
    re_path(r'^tenant/update/(?P<pk>[0-9a-f-]+)/$', views.TenantUpdateView.as_view(), name='tenant_update'),
    re_path(r'^tenant/delete/(?P<pk>[0-9a-f-]+)/$', views.TenantDeleteView.as_view(), name='tenant_delete'),

    # Tenant year URLs
    re_path(r'^assign-tenant-unit/create/$', views.TenantUnitAssignCreateView.as_view(), name='tenant_unit_assign_create'),
    re_path(r'^assign-tenant-unit/list/$', views.TenantUnitAssignListView.as_view(), name='tenant_unit_assign_list'),
    re_path(r'^assign-tenant-unit/update/(?P<pk>[0-9a-f-]+)/$', views.TenantUnitAssignUpdateView.as_view(), name='tenant_unit_assign_update'),
    re_path(r'^assign-tenant-unit/delete/(?P<pk>[0-9a-f-]+)/$', views.TenantUnitAssignDeleteView.as_view(), name='tenant_unit_assign_delete'),
]

properties/models.py
from decimal import Decimal

from django.core.validators import MinValueValidator
from django.db import models
from django.utils.translation import gettext_lazy as _

from core.models import BaseModel
from tenants.models import TenantUnitAssign


class Feature(BaseModel):
    name = models.CharField(max_length=256)

    class Meta:
        verbose_name = _('Feature')
        verbose_name_plural = _('Features')

    def __str__(self):
        return self.name


class Property(BaseModel):
    name = models.CharField(max_length=256)
    address = models.TextField(null=True, blank=True)
    location = models.CharField(max_length=256)
    features = models.ManyToManyField(Feature, limit_choices_to={'is_deleted': False})

    class Meta:
        verbose_name = _('Property')
        verbose_name_plural = _('Properties')

    def __str__(self):
        return self.name

    def features_names(self):
        return ", ".join([i.name for i in self.features.all()])


class Unit(models.Model):
    UNIT_CHOICES = [
        ('1BHK', '1BHK'),
        ('2BHK', '2BHK'),
        ('3BHK', '3BHK'),
        ('4BHK', '4BHK'),
    ]

    name = models.CharField(max_length=255)
    unit_type = models.CharField("Unit Types", max_length=10, choices=UNIT_CHOICES, default='1BHK')  # TODO: Add dynamic choices
    property = models.ForeignKey(Property, on_delete=models.CASCADE, limit_choices_to={'is_deleted': False})
    rent = models.DecimalField(default=0, decimal_places=2,  max_digits=15, validators=[MinValueValidator(Decimal('0.00'))])
    cost = models.DecimalField(default=0, decimal_places=2,  max_digits=15, validators=[MinValueValidator(Decimal('0.00'))])

    def get_assigned_tenant(self):
        return TenantUnitAssign.objects.filter(is_active=True, unit=self).first()

    def __str__(self):
        return f"{self.name} - {self.get_unit_type_display()}"

properties/forms.py
from django import forms

from properties.models import Feature, Property, Unit


class FeatureForm(forms.ModelForm):

    class Meta:
        model = Feature
        exclude = ['creator', 'updater', 'date_updated', 'auto_id', 'is_deleted']

        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Name'}),
        }


class PropertyForm(forms.ModelForm):

    class Meta:
        model = Property
        exclude = ['creator', 'updater', 'date_updated', 'auto_id', 'is_deleted']

        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Name'}),
            'location': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Location'}),
            'address': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Address'}),
            'features': forms.SelectMultiple(attrs={'class': 'form-control', 'placeholder': 'Address'}),
        }


class UnitForm(forms.ModelForm):

    class Meta:
        model = Unit
        exclude = ['property']

        widgets = {
            'name': forms.TextInput(attrs={'class': 'required form-control', 'placeholder': 'Name'}),
            'unit_type': forms.Select(attrs={'class': 'required form-control', 'placeholder': 'Unit Type'}),
            'rent': forms.NumberInput(attrs={'class': 'required form-control', 'placeholder': 'Rent'}),
            'cost': forms.NumberInput(attrs={'class': 'required form-control', 'placeholder': 'Cost'})
        }

properties/views.py
import json

from django.db.models import Q
from django.forms.formsets import formset_factory
from django.forms.models import inlineformset_factory
from django.http import HttpResponse
from django.shortcuts import render
from django.urls import reverse
from django.utils import timezone
from django.utils.decorators import method_decorator
from django.views.generic import DetailView, ListView, View
from django.views.generic.detail import SingleObjectMixin
from django_filters.views import FilterView

from core.functions import CPaginator, generate_form_errors, get_auto_id
from core.views import CheckSuperRolesMixin
from properties.filters import FeatureFilter, PropertyFilter
from properties.forms import FeatureForm, PropertyForm, UnitForm
from properties.models import Feature, Property, Unit


class FeatureCreateView(CheckSuperRolesMixin, View):
    def get(self, *args, **kwargs):
        form = FeatureForm()

        context = {
            "form": form,
            "title": "Create Feature",
            "redirect": True,
            "active_menu": "feature",
        }
        return render(self.request, "properties/feature/feature_entry.html", context)

    def post(self, *args, **kwargs):

        form = FeatureForm(self.request.POST)

        if form.is_valid():

            data = form.save(commit=False)
            data.auto_id = get_auto_id(Feature)
            data.creator = self.request.user
            data.date_added = timezone.now()
            data.save()

            response_data = {
                "status": "true",
                "title": "Successfully Created",
                "message": "Feature created successfully.",
                "redirect": "true",
                "redirect_url": reverse('properties:feature_list')
            }

        else:
            message = str(generate_form_errors(form, formset=False))

            response_data = {
                "status": "false",
                "title": "Form validation error",
                "message": message
            }

        return HttpResponse(json.dumps(response_data), content_type='application/javascript')


class FeatureUpdateView(CheckSuperRolesMixin, SingleObjectMixin, View):
    model = Feature

    def post(self, *args, **kwargs):
        self.object = self.get_object()
        form = FeatureForm(self.request.POST, instance=self.object)
        if form.is_valid():
            data = form.save(commit=False)
            data.updater = self.request.user
            data.date_updated = timezone.now()
            data.save()

            response_data = {
                "status": "true",
                "title": "Successfully Updated",
                "message": "Feature Successfully Updated.",
                "redirect": "true",
                "redirect_url": reverse('properties:feature_list')
            }
        else:
            message = generate_form_errors(form, formset=False)
            response_data = {
                "status": "false",
                "stable": "true",
                "title": "Form validation error",
                "message": message
            }

        return HttpResponse(json.dumps(response_data), content_type='application/javascript')

    def get(self, *args, **kwargs):
        self.object = self.get_object()
        form = FeatureForm(instance=self.object)

        context = {
            "form": form,
            "title": "Edit Feature : " + self.object.__str__(),
            "instance": self.object,
            "redirect": True,
            "active_menu": "feature",
            "is_edit_page": True,
        }
        return render(self.request, "properties/feature/feature_entry.html", context)


class FeatureListView(CheckSuperRolesMixin, FilterView):
    model = Feature
    paginate_by = 21
    paginator_class = CPaginator
    template_name = "properties/feature/feature_list.html"
    context_object_name = "instances"
    filterset_class = FeatureFilter

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        context["title"] = "Feature"
        context["active_menu"] = "feature"

        return context


class FeatureDetailView(CheckSuperRolesMixin, DetailView):
    model = Feature
    template_name = "properties/feature/feature_view.html"
    context_object_name = "instance"

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        context["title"] = "Feature"
        context["active_menu"] = "feature"
        context['instance_form_data'] = FeatureForm(instance=self.get_object())

        return context


class FeatureDeleteView(CheckSuperRolesMixin, SingleObjectMixin, View):
    model = Feature

    def get(self, *args, **kwargs):
        self.object = self.get_object()
        self.object.is_deleted = True
        self.object.save()

        response_data = {
            "status": "true",
            "title": "Successfully Deleted",
            "message": "Feature Successfully Deleted.",
            "redirect": "true",
            "redirect_url": reverse('properties:feature_list')
        }
        return HttpResponse(json.dumps(response_data), content_type='application/javascript')


class PropertyCreateView(CheckSuperRolesMixin, View):
    UnitFormset = formset_factory(UnitForm, extra=1)

    def get(self, *args, **kwargs):
        unit_formset = self.UnitFormset(prefix="unit_formset")
        form = PropertyForm()
        context = {
            "form": form,
            "title": "Create Property",
            "redirect": True,
            "active_menu": "property",
            'unit_formset': unit_formset
        }
        return render(self.request, "properties/property/property_entry.html", context)

    def post(self, *args, **kwargs):

        form = PropertyForm(self.request.POST)

        unit_formset = self.UnitFormset(self.request.POST, self.request.FILES, prefix='unit_formset', form_kwargs={'empty_permitted': False})

        if form.is_valid() and unit_formset.is_valid():

            data = form.save(commit=False)
            data.auto_id = get_auto_id(Property)
            data.creator = self.request.user
            data.save()
            form.save_m2m()

            for item in unit_formset:
                unit_data = item.save(commit=False)
                unit_data.property = data
                unit_data.save()

            response_data = {
                "status": "true",
                "title": "Successfully Created",
                "message": "Property created successfully.",
                "redirect": "true",
                "redirect_url": reverse('properties:property_list')
            }

        else:
            message = str(generate_form_errors(form, formset=False))
            message += str(generate_form_errors(unit_formset, formset=True))

            response_data = {
                "status": "false",
                "title": "Form validation error",
                "message": message
            }

        return HttpResponse(json.dumps(response_data), content_type='application/javascript')


class PropertyUpdateView(CheckSuperRolesMixin, SingleObjectMixin, View):
    model = Property

    def get_formset(self):
        instance = self.get_object()
        extra = 0 if Unit.objects.filter(property=instance).exists() else 1
        UnitFormset = inlineformset_factory(
            Property,
            Unit,
            can_delete=True,
            extra=extra,
            form=UnitForm,
        )
        return UnitFormset

    def post(self, *args, **kwargs):
        self.object = self.get_object()
        form = PropertyForm(self.request.POST, instance=self.object)
        UnitFormset = self.get_formset()
        unit_formset = UnitFormset(self.request.POST, self.request.FILES, instance=self.object, prefix='unit_formset', form_kwargs={'empty_permitted': False})
        if form.is_valid() and unit_formset.is_valid():
            data = form.save(commit=False)
            data.updater = self.request.user
            data.date_updated = timezone.now()
            data.save()
            form.save_m2m()

            for item in unit_formset:
                if item not in unit_formset.deleted_forms:
                    d_data = item.save(commit=False)
                    d_data.save()

            for f in unit_formset.deleted_forms:
                f.instance.delete()

            response_data = {
                "status": "true",
                "title": "Successfully Updated",
                "message": "Property Successfully Updated.",
                "redirect": "true",
                "redirect_url": reverse('properties:property_list')
            }
        else:
            message = generate_form_errors(form, formset=False)
            response_data = {
                "status": "false",
                "stable": "true",
                "title": "Form validation error",
                "message": message
            }

        return HttpResponse(json.dumps(response_data), content_type='application/javascript')

    def get(self, *args, **kwargs):
        self.object = self.get_object()
        form = PropertyForm(instance=self.object)
        UnitFormset = self.get_formset()
        unit_formset = UnitFormset(instance=self.object, prefix="unit_formset")
        context = {
            "form": form,
            "title": "Edit Property : " + self.object.__str__(),
            "instance": self.object,
            "redirect": True,
            "active_menu": "property",
            "is_edit_page": True,
            'unit_formset': unit_formset

        }
        return render(self.request, "properties/property/property_entry.html", context)


class PropertyListView(CheckSuperRolesMixin, FilterView):
    model = Property
    paginate_by = 21
    paginator_class = CPaginator
    template_name = "properties/property/property_list.html"
    context_object_name = "instances"
    filterset_class = PropertyFilter

templates/properties/property/property_list.html
{% extends "base.html" %}
{% load static %}
{% load i18n %}
{% block content %}




<div class="row">
    <div class="col-12">
        <div class="card">
            <div class="card-header">
                <div class="row align-items-center">
                    <div class="col" style="flex-grow:2">
                        <h4 class="card-title">{{title}}</h4>
                    </div>
                    <!--end col-->
                    <div class="col-auto" style="flex-grow:1">
                        <form action=".">
                            <div class="row">
                                <div class="col-md-3">
                                    {{filter.form.unit_type}}
                                </div>
                                <div class="col-md-6">
                                    {{filter.form.q}}
                                </div>
                                <div class="col-md-3">
                                    <button class="btn  btn-soft-primary" role="button">Submit</button>
                                </div>
                            </div>
                        </form>
                    <!--end col-->
                </div>
                <!--end row-->
            </div>
            <!--end card-header-->
            <div class="card-body">
                <div class="table-responsive">

                    {% if instances %}
                    <table class="table mb-0">
                        <thead class="thead-light">
                            <tr>
                                <th>Sl.no</th>
                                <th>Name</th>
                                <th>Address</th>
                                <th>Location</th>
                                <th>Features</th>
                                <th>Units</th>
                                <th>Creator</th>
                                <th>Updater</th>
                                <th class="text-right">Action</th>
                            </tr>
                        </thead>
                        <tbody>
                            {% for instance in instances %}
                            <tr>
                                <td>{% if page_obj.has_other_pages %}{{ forloop.counter0|add:page_obj.start_index }}{% else %}{{forloop.counter}}{% endif %}</td>
                                <td>{{instance.name}}</td>
                                <td>{{instance.address}}</td>
                                <td>{{instance.location}}</td>
                                <td>{{instance.features_names}}</td>
                                <td>{{instance.unit_set.all.count}}</td>
                                <td>{{instance.creator}} ({{instance.date_added|date:datetime_format}})</td>
                                <td>{{instance.updater|default:"-"}} {% if instance.date_updated %}({{instance.date_updated|date:datetime_format}}){% endif %}</td>
                                <td class="text-right">
                                    <a href="{% url 'properties:property_view' instance.pk %}"><i class="las la-eye text-info font-18" title="View"></i></a>
                                    <a href="{% url 'properties:property_update' instance.pk %}"><i class="las la-pen text-warning font-18" title="Edit"></i></a>
                                    <a href="{% url 'properties:property_delete' instance.pk %}" data-id="{{instance.pk}}" data-text="Are you sure you want to delete this item?" data-title="Are you sure?" class="action-button remove"><i class="las la-trash-alt text-danger font-18" title="Delete"></i></a>
                                </td>
                            </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                    {% include 'includes/pagination.html' %}
                    {% else %}
                    {% include 'includes/not_found.html' %}
                    {% endif %}

                </div>
                <!--end table-responsive-->
            </div>
            <!--end card-body-->
        </div>
        <!--end card-->
    </div>
    <!--end col-->
</div>
{% endblock %}
{% block static %}
{% endblock %}

templates/properties/property/property_view.html
{% extends "base.html" %}
{% load static %}
{% load i18n %}
{% block content %}


<div class="row">
    <div class="col-lg-12">
        <div class="card">
            <div class="card-header d-flex justify-content-between">
                <h4 class="card-title">Details</h4>

                <div class="button-items text-right">
                    <a href="{% url 'properties:property_update' instance.pk %}" class="btn btn-warning btn-icon-square-sm"><i class="fas fa-pen"></i></a>
                    <a href="{% url 'properties:property_delete' instance.pk %}" data-id="{{ instance.pk }}" data-text="Are you sure you want to delete this Item?" data-title="Are you sure?" class="btn btn-danger btn-icon-square-sm action-button remove redirect"><i class="fas fa-trash-alt" title="Delete"></i></a>
                </div>
            </div>
            <div class="card-body">
                <div class="row">
                    <div class="list-group lg-alt c-overflow col-md-4 mb-2">
                        <div class="list-group-item media">
                            <div class="media-body">
                                <div class="lgi-heading">Name</div><small class="lgi-text"> {{instance.name}}</small>
                            </div>
                        </div>
                    </div>
                    <div class="list-group lg-alt c-overflow col-md-4 mb-2">
                        <div class="list-group-item media">
                            <div class="media-body">
                                <div class="lgi-heading">Address</div><small class="lgi-text"> {{instance.address}}</small>
                            </div>
                        </div>
                    </div>
                    <div class="list-group lg-alt c-overflow col-md-4 mb-2">
                        <div class="list-group-item media">
                            <div class="media-body">
                                <div class="lgi-heading">Location</div><small class="lgi-text"> {{instance.location}}</small>
                            </div>
                        </div>
                    </div>

                    <div class="list-group lg-alt c-overflow col-md-4 mb-2">
                        <div class="list-group-item media">
                            <div class="media-body">
                                <div class="lgi-heading">Creator</div><small class="lgi-text"> {{instance.creator}} ({{instance.date_added|date:datetime_format}})</small>
                            </div>
                        </div>
                    </div>

                    <div class="list-group lg-alt c-overflow col-md-4 mb-2">
                        <div class="list-group-item media">
                            <div class="media-body">
                                <div class="lgi-heading">Updater</div><small class="lgi-text"> {{instance.updater|default:"-"}} {% if instance.date_updated %}({{instance.date_updated|date:datetime_format}}){% endif %}</small>
                            </div>
                        </div>
                    </div>


                </div>



            </div>
            <div class="col-lg-12">
                <div class="card">
                    <div class="card-header d-flex justify-content-between">
                        <h4 class="card-title">Units</h4>
                    </div>
                    <div class="card-body">
                        <div class="row">
                            <table class="table table-tranx">
                                <thead>
                                    <tr>
                                        <th>Name</th>
                                        <th>Type</th>
                                        <th>Rent</th>
                                        <th>Cost</th>
                                        <th>Tenant</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    {% for unit in instance.unit_set.all %}
                                    <tr class="form_set_row">

                                        <td>{{unit.name}}</td>
                                        <td>{{unit.get_unit_type_display}}</td>
                                        <td>{{unit.rent}}</td>
                                        <td>{{unit.cost}}</td>
                                        <td>
                                            {% if unit.get_assigned_tenant %}
                                            <a href="{% url 'tenants:tenant_view' unit.get_assigned_tenant.tenant.pk %}"><i class="ti-new-window"></i>&nbsp;</a>{{unit.get_assigned_tenant}}
                                            {% else %}
                                            <a class="btn btn-sm btn-primary" href="{% url 'tenants:tenant_unit_assign_create' %}?next={{request.path}}&unit={{unit.pk}}">Assign</a>
                                            {% endif %}
                                        </td>

                                    </tr>
                                    {% endfor %}
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>

        </div>
    </div>
    <!--end col-->
</div>

{% endblock %}
{% block static %}
{% endblock %}